import {gqlLogin, gqlRegistration} from "../../shared/services&utilits/gqlRequest";
import {jwtDecode} from "../../shared/services&utilits/utilits";
import {Link} from "react-router-dom";

export const changeAuthData = authData => ({
    type: "CHANGE_AUTH_DATA",
    payload: authData
})

export const setError = error => ({
    type: "SET_ERROR",
    payload: error
})

export const changeAuthDataAsync = ({login, password, authType, navigateCallback}) => {
    console.log(navigateCallback)
     return async (dispatch) => {
        let response = ""
        if (authType === "signUp") {
            console.log("Регистрация")
            response = await gqlRegistration(login, password)
            if (!response.ok) {
                dispatch(setError("Server is not answer"))
            }

            const responseData = await response.json();
            console.log(responseData)
            const user = responseData.data.createUser;

            if (user) {
                dispatch(changeAuthDataAsync({login, password, authType: "signIn", navigateCallback}))
            } else {
                dispatch(setError("Login is already exist"))
            }
        }
        if (authType === "signIn") {
            console.log(login,password)
            response = await gqlLogin(login, password)
            console.log(response)
            if (!response.ok) {
                dispatch(setError("Server is not answer"))
            }
            const responseData = await response.json();
            console.log(responseData)
            const token = responseData.data.login;
            console.log(token)
            if (jwtDecode(token)){
                localStorage.authToken = token
            }
            // console.log(jwtDecode(token))


            if (!token) {
                dispatch(setError("Wrong login or password"))
            } else {
                dispatch(changeAuthData({token: token, user: jwtDecode(token)}))
                dispatch(setError(null))
                console.log(navigateCallback)
                navigateCallback("../profile")
            }
        }
         if (authType === "ownerData") {

         }
    }
};
