
const initialState={
    auth: {
        token: "",
        user: ""
    },
    error:{
        auth: null,
    }
}
const rootReducer=(state = initialState, action)=>{
    switch (action.type){
        case "CHANGE_AUTH_DATA" :
            return {
                ...state, auth: action.payload

            }
        case "SET_ERROR" :
            return {
                ...state, error: {...state.error, auth: action.payload}
            }
    }
    return state
}

export default rootReducer;

